from typing import Iterable, List, Optional, Tuple
from dpcontracts import require, ensure
from kitchensink.utility.splitter import Splitter
from argument_predictor.statistical.resolver import PredictionContext
from argument_predictor.statistical.statistics import StatisticsDB

DEFAULT_TOP_K = 10
DEFAULT_THRESHOLD = 0.04


class Predictor:
    """
    base class for predicting an argument for a method call
    using parameter name (if available) and statistical information
    """

    def __init__(self, statistics_db: StatisticsDB, splitter: Splitter):
        """
        :param statistics_db: contains statistical information about typical
          argument names and constants used at a given context
        :param splitter: an instance of a name splitting algorithm
        """
        self.statistics_db = statistics_db
        self.splitter = splitter

    @staticmethod
    def _max_term_similarity(
        term: str,
        terms: List[str],
    ) -> float:
        """
        score a term against a list of terms generated by splitting an
        identifier into terms using name splitting algorithm

        :param term: a commonly used term
        :param terms: a identifier split into terms
        :return: a score between 0.0 and 1.0 based on the maximal similarity of
            @term to @terms
        """

        def is_penalized_match() -> bool:
            """
            predicate for whether a penalty should be assessed for a single
            letter match.

            :return: true if a penalty should be assessed
            """
            # If the term is a single letter and the name split contains
            # multiple terms, penalize the single-letter match.
            return len(term) == 1 and len(terms) > 1

        result = 0.0

        if term in terms:
            # We found an exact match.
            result = 1.0 if not is_penalized_match() else 0.25

        return result

    @staticmethod
    def _similarity_score(
        a: str,
        b: str,
        splitter: Splitter,
    ) -> float:
        """
        compute a similarity score between two identifiers, @a and @b

        :param a: first identifier
        :param b: second identifier
        :param splitter: an instance of a name splitting algorithm to split the
            identifiers into terms
        :return: score between 0.0 and 1.0
        """

        # Split the two identifiers into terms (e.g. "JSON_Encoder" ->
        # ["JSON", "Encoder"]).  Order the identifiers such that b_terms
        # always contains an equal or greater number of terms than
        # a_terms to ensure the score computation is symmetric.
        terms = [splitter.split_lower(a), splitter.split_lower(b)]
        terms = sorted(terms)  # first sort lexigraphically for tiebreakers
        terms = sorted(terms, key=len)  # stable sort by list length
        a_terms, b_terms = terms

        # Compute the similarity score by finding the average
        # similarity between each term in @a with the terms in @b.
        score = 0.0
        for term in a_terms:
            score += Predictor._max_term_similarity(term, b_terms)
        return score / len(b_terms)

    @staticmethod
    def _score_names(
        splitter: Splitter,
        names: Iterable[str],
        top_arg_terms: List[Tuple[str, float]],
        param_name: Optional[str],
    ) -> List[float]:
        """
        score the list of names, according to `top_arg_terms` and `param_name`
        return a corresponding list of scores (1-1 with names)

        :param splitter: an instance of a name splitting algorithm
        :param names: the names that need scoring
        :param top_arg_terms: list of pairs (argument terms, scores)
        :param param_name: optional param name, when we are able to resolve
            the method
        :return: a list of scores for names
        """
        scores = []
        for name in names:
            best_score = (
                Predictor._similarity_score(param_name, name, splitter)
                if param_name
                else 0.0
            )
            name_terms = splitter.split_lower(name)
            for arg_term, arg_prob in top_arg_terms:
                sim = Predictor._max_term_similarity(arg_term, name_terms)
                best_score = max(best_score, arg_prob * sim)
            scores.append(best_score)

        return scores

    @require("`top_k` must be a positive value", lambda args: args.top_k > 0)
    @require(
        "`threshold` must be a value between [0.0, 1.0]",
        lambda args: 0.0 <= args.threshold <= 1.0,
    )
    @ensure(
        "do not return more than `top_k` results",
        lambda args, result: len(result) <= args.top_k,
    )
    def predict_argument(
        self,
        context: PredictionContext,
        top_k: int = DEFAULT_TOP_K,
        threshold: float = DEFAULT_THRESHOLD,
    ) -> List[str]:
        """
        predict an argument given the context

        :param context: context from which argument is predicted
        :param top_k: limit to the top k predictions
        :param threshold: mininum score (between [0.0, 1.0]) for a prediction
        :return: list of argument predictions
        """
        # retrieve the top arguments and constants from the database
        top_arg_terms = self.statistics_db.top_arg_terms(context)
        top_arg_constants = self.statistics_db.top_arg_constants(context)

        # score the names which are in scope at the given point
        name_scores = self._score_names(
            self.splitter,
            context.in_scope_names,
            top_arg_terms,
            context.get_param_name(),
        )
        top_names = zip(context.in_scope_names, name_scores)
        top_names = [(name, score) for name, score in top_names if score > threshold]

        # (1) Concatenate the argument constants and matching in scope names.
        # (2) Sort the result by score, descending.
        # (3) Return only the top TOP_K results.
        # (4) Return only the values, not the scores.
        predictions = top_arg_constants + top_names  # (1)
        predictions = sorted(predictions, reverse=True, key=lambda x: x[1])  # (2)
        predictions = predictions[:top_k]  # (3)
        predictions = [value for value, score in predictions]  # (4)

        return predictions
